"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pdfViewer = void 0;
const path_1 = __importStar(require("path"));
const fs_1 = require("fs");
const serve_static_1 = __importDefault(require("serve-static"));
const utils_1 = require("./utils");
function pdfViewer(options) {
    const buildDir = path_1.default.resolve((options === null || options === void 0 ? void 0 : options.build) || "./node_modules/pdfjs-viewer-build/viewer/");
    const prefix = path_1.posix.join("/", (options === null || options === void 0 ? void 0 : options.base) || "", "/");
    const indexName = "index.html";
    const indexBuildPath = path_1.default.join(buildDir, indexName);
    const exclude = [".js.map", ".css.map", '.pdf'];
    if ((options === null || options === void 0 ? void 0 : options.index) == false) {
        exclude.push(indexName);
    }
    let outDir;
    let sourcePromise = Promise.resolve("");
    const testHtmlPath = (p) => path_1.posix.join(path_1.posix.dirname(p), "/") === prefix;
    return {
        name: "vite-plugin-pdfjs-viewer",
        configResolved(config) {
            outDir = (options === null || options === void 0 ? void 0 : options.out) || path_1.default.join(config.build.outDir, prefix);
        },
        buildStart() {
            sourcePromise = fs_1.promises.readFile(indexBuildPath, { encoding: "utf8" });
        },
        transformIndexHtml(html, ctx) {
            return __awaiter(this, void 0, void 0, function* () {
                let out = "";
                if (testHtmlPath(ctx.path) && (out = yield sourcePromise)) {
                    out = (0, utils_1.injectHTML)(out, html, "head");
                    out = (0, utils_1.injectHTML)(out, html, "body");
                }
                return out || html;
            });
        },
        configureServer(server) {
            const route = path_1.posix.join("/", server.config.base, prefix);
            server.middlewares.use(route, (0, serve_static_1.default)(buildDir, Object.assign(Object.assign({}, options === null || options === void 0 ? void 0 : options.serve), { index: (options === null || options === void 0 ? void 0 : options.index) === false ? false : undefined })));
        },
        closeBundle() {
            return __awaiter(this, void 0, void 0, function* () {
                yield (0, utils_1.copyFilesRecursive)(buildDir, outDir, exclude);
            });
        }
    };
}
exports.pdfViewer = pdfViewer;
exports.default = pdfViewer;
