"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.injectHTML = exports.copyFilesRecursive = void 0;
const path = __importStar(require("path"));
const fs = __importStar(require("fs/promises"));
function copyFilesRecursive(src, dst, exclude) {
    return __awaiter(this, void 0, void 0, function* () {
        const files = yield getFiles(src);
        yield Promise.all(files
            .filter(p => exclude ? (exclude.find(end => p.endsWith(end)) ? false : true) : true)
            .map((file) => __awaiter(this, void 0, void 0, function* () {
            const src_ = path.relative(src, file);
            const dst_ = path.join(dst, src_);
            yield fs.mkdir(path.dirname(dst_), { recursive: true });
            yield fs.copyFile(file, dst_);
        })));
    });
}
exports.copyFilesRecursive = copyFilesRecursive;
function getFiles(src = "./") {
    return __awaiter(this, void 0, void 0, function* () {
        const entries = yield fs.readdir(src, { withFileTypes: true });
        const files = entries
            .filter(file => !file.isDirectory())
            .map(file => path.join(src, file.name));
        const folders = entries.filter(folder => folder.isDirectory());
        yield Promise.all(folders.map((folder) => __awaiter(this, void 0, void 0, function* () {
            const innerSrc = path.join(src, folder.name);
            const innerFiles = yield getFiles(innerSrc);
            files.push(...innerFiles);
        })));
        return files;
    });
}
function injectHTML(dst, src, target) {
    var _a;
    const regexes = {
        "head": /<head>(.*?<\/head>)/s,
        "body": /<body>(.*?<\/body>)/s,
    };
    const search = `</${target}>`;
    return dst.replace(search, ((_a = src.match(regexes[target])) === null || _a === void 0 ? void 0 : _a[1]) || search);
}
exports.injectHTML = injectHTML;
